/*	File code.c: 2.2 (84/08/31,10:05:13) */
/*% cc -O -c %
 *
 */

#include <stdio.h>
#include "defs.h"
#include "data.h"

int segment;

/*
 *	print all assembler info before any code is generated
 *
 */
header ()
{
	outstr("; Small C HuC6280 (v0.2, 08/Nov/97)\n;\n");
	outstr("; Taken to HuC (22/Feb/00)\n;\n");
	outstr("HUC\t= 1\n");
	outstr("\t.include \"startup.asm\"\n");
        /*
         * TODO : check whether it's here it's needed to put org and code statements
         * remove the bank 1 for bank MAIN_BANK when assembling with true magic kit
         * include files, not special ones
         */
	outstr("\t.data\n");
	outstr("\t.bank MAIN_BANK+1\n\t.org $6000\n");
	gtext ();
	nl ();
}

gdata ()
{
	if (segment == 1) {
		segment  = 0;
		ol (".bss");
	}
}

gtext ()
{
	if (segment == 0) {
		segment  = 1;
		ol (".code");
	}
}

/*
 *	print pseudo-op  to define a byte
 *
 */
defbyte ()
{
	ot (".db\t");
}

/*
 *	print pseudo-op to define storage
 *
 */
defstorage ()
{
	ot (".ds\t");
}

/*
 *	print pseudo-op to define a word
 *
 */
defword ()
{
	ot (".dw\t");
}

out_ins(int code, int type, int data)
{
	INS tmp;

	tmp.code = code;
	tmp.type = type;
	tmp.data = data;

	if (optimize)
		push_ins(&tmp);
	else
		gen_code(&tmp);
}

gen_code(INS *tmp)
{
	int code;
	int type;
	int data;

	code = tmp->code;
	type = tmp->type;
	data = tmp->data;

	if (type == T_NOP)
		return;

	switch (code) {
	case I_LDB:
		ot("  ldx\t");

		switch (type) {
		case T_LABEL:
			outlabel(data);
			break;
		default:
			outsymbol(data);
			break;
		}
		nl();
		break;

	case I_LDBP:
		ol("__ldbp\t__ptr");
		break;

	case I_LDW:
		ot("__ldw\t");

		switch (type) {
		case T_SYMBOL:
			outsymbol(data);
			break;
		case T_LABEL:
			outlabel(data);
			break;
		case T_STACK:
			outstr("__stack");
			break;
		}
		nl();
		break;

	case I_LDWI:
		ot("__ldwi\t");

		switch (type) {
		case T_VALUE:
			outdec(data);
			break;
		case T_LABEL:
			outlabel(data);
			break;
		case T_SYMBOL:
			outsymbol(data);
			break;
		case T_STRING:
			outlabel(litlab);
			outbyte('+');
			outdec(data);
			break;
		}
		nl();
		break;

	case I_LDWP:
		ol("__ldwp\t__ptr");
		break;

	case I_STB:
		ot("  stx\t");

		switch (type) {
		case T_LABEL:
			outlabel(data);
			break;
		default:
			outsymbol(data);
			break;
		}
		nl();
		break;

	case I_STBPS:
		ol("__stbps");
		break;

	case I_STW:
		ot("__stw\t");

		switch (type) {
		case T_LABEL:
			outlabel(data);
			break;
		case T_SYMBOL:
			outsymbol(data);
			break;
		case T_PTR:
			outstr("__ptr");
			break;
		}
		nl();
		break;
	
	case I_STWPS:
		ol("__stwps");
		break;

	case I_ADDWI:
		ot("__addwi\t");
		outdec(data);
		nl();
		break;

	case I_ADDWS:
		ol("__addws");
		break;

	case I_ADDMI:
		ot("__addmi\t");
		outdec(data);
		outstr(",__stack");
		nl();
		break;

	case I_SUBWI:
		ot("__subwi\t");
		outdec(data);
		nl();
		break;

	case I_SUBWS:
		ol("__subws");
		break;

	case I_ORWS:
		ol("__orws");
		break;

	case I_EORWS:
		ol("__eorws");
		break;

	case I_ANDWS:
		ol("__andws");
		break;

	case I_ASLW:
		ol("__aslw");
		break;

	case I_ASLWS:
		ol("__aslws");
		break;

	case I_ASRW:
		ol("__asrw");
		break;

	case I_COMW:
		ol("__comw");
		break;

	case I_NEGW:
		ol("__negw");
		break;

	case I_SWAPW:
		ol("__swapw");
		break;

	case I_EXTW:
		ol("__extw");
		break;

	case I_BOOLW:
		ol("__boolw");
		break;

	case I_NOTW:
		ol("__notw");
		break;

	case I_JMP:
		ot("  jmp\t");
		outsymbol(data);
		nl();
		break;

	case I_JSR:
		ot("  jsr\t");

		switch (type) {
		case T_SYMBOL:
			outsymbol(data);
			break;
		case T_LIB:
			outstr(data);
			break;
		}
		nl();
		break;

	case I_CALLS:
		ot("  call\t");

		switch (type) {
		case T_SYMBOL:
			outsymbol(data);
			break;
		case T_LIB:
			outstr(data);
			break;
		}
		nl();
		break;

	case I_RTS:
		ol("  rts");
		break;

	case I_PUSHW:
		ol("__pushw");
		break;

	case I_PUSHWZ:
		ot("__pushwz\t");
		outdec(data);
		nl();
		break;

	case I_POPW:
		ol("__popw");
		break;

	case I_TSTW:
		ol("__tstw");
		break;

	case I_LBRA:
		ot("__lbra\t");
		outlabel(data);
		nl();
		break;

	case I_LBEQ:
		ot("__lbeq\t");
		outlabel(data);
		nl();
		break;

	case I_LBNE:
		ot("__lbne\t");
		outlabel(data);
		nl();
		break;

	case I_BANK:
		ot(".bank\t");
		switch (type) {
		case T_VALUE:
			outdec(data);
			break;
		default:
			error("bank type switching not handled");
			break;
		}
		nl();
		break;

	case I_OFFSET:
		ot(".org\t");
		switch (type) {
		case T_VALUE:
			outhex((unsigned short)data);
			break;
		default:
			error("org type setting not handled");
			break;
		}
		nl();
		break;

	default:
		gen_asm(tmp);
		break;
	}
}

